#include "../Utils/Memory.h"

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;


struct Triangle {
	float a,b,c,d;
};

int main(int argc,char **argv) {
	GrowArray<Triangle> cellTriangles(512);
	TailPool<unsigned>  cellPrimitives(1024);

	srand(time(0));

	unsigned data[10000];
	for(int i=0;i<10000;i++)
		data[i] = rand() % 100;

	for(int i=0;i<10000;i++)
		cellPrimitives.getMem(data[i]);

	for(int i=0;i<512;i++)
		cellTriangles.getNext();

	for(int i=9999;i>=5000;i--)
		cellPrimitives.returnMem(data[i]);

	unsigned *bla = new unsigned[17548];

	for(int i=5000;i<10000;i++)
		cellPrimitives.getMem(data[i]);

	for(int i=0;i<512;i++)
		cellTriangles.getNext();

	for(int i=9999;i>=0;i--)
		cellPrimitives.returnMem(data[i]);

	delete bla;
};